Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15189)
@@ -2,8 +2,8 @@
   using System.Collections.Generic;
   using System.Globalization;
-  using System.Text;
   using Attributes;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
+
   using Interpreter;
   using Stack;
@@ -21,5 +21,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      interpreter.PrintStack.Push(string.Empty);
+      interpreter.PrintStack.NewLine();
     }
   }
@@ -28,35 +28,29 @@
   public abstract class PrintExpression<T> : StatelessExpression {
     protected PrintExpression() { }
+
     [StorableConstructor]
     protected PrintExpression(bool deserializing) : base(deserializing) { }
 
     protected void Eval(IInternalPushInterpreter interpreter, IPushStack<T> stack) {
-      var value = stack.Pop().ToString();
-
-      if (interpreter.PrintStack.IsEmpty)
-        interpreter.PrintStack.Push(value);
-      else
-        interpreter.PrintStack.Top += value;
+      var value = stack.Pop();
+
+      interpreter.PrintStack.Push(value);
     }
 
     protected void EvalVector(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
-      var sb = new StringBuilder();
       var vector = vectorStack.Pop();
 
-      sb.Append(PushEnvironment.VectorStartSymbol);
+      interpreter.PrintStack.Push(PushEnvironment.VectorStartSymbol);
 
       if (vector.Count > 0) {
-        sb.Append(vector[0]);
+        interpreter.PrintStack.Push(vector[0]);
 
         for (var i = 1; i < vector.Count; i++) {
-          sb.Append(PushEnvironment.VectorSeparatorSymbol);
-          sb.Append(vector[i]);
+          interpreter.PrintStack.Push(PushEnvironment.VectorSeparatorSymbol);
+          interpreter.PrintStack.Push(vector[i]);
         }
       }
 
-      sb.Append(PushEnvironment.VectorEndSymbol);
-
-      var value = sb.ToString();
-      interpreter.PrintStack.Push(value);
+      interpreter.PrintStack.Push(PushEnvironment.VectorEndSymbol);
     }
   }
@@ -165,5 +159,6 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.IntegerStack);
+      var value = interpreter.IntegerStack.Pop();
+      interpreter.PrintStack.Push(value);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15189)
@@ -8,4 +8,7 @@
   using Data.Pool;
   using Extensions;
+
+  using HeuristicLab.Common;
+
   using Interpreter;
   using Persistence.Default.CompositeSerializers.Storable;
@@ -41,4 +44,16 @@
     }
 
+    public PushProgram(PushProgram origin, Cloner cloner) {
+      stringRepresentation = origin.stringRepresentation;
+      hashCode = origin.hashCode;
+      depth = origin.depth;
+      treeIndex = origin.treeIndex;
+      expressions = new List<Expression>(origin.expressions);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushProgram(this, cloner);
+    }
+
     public bool IsEmpty { get { return Count == 0; } }
     public int Count { get { return expressions.Count; } }
@@ -51,4 +66,6 @@
       return program;
     }
+
+    void IPooledObject.Init() { }
 
     void IPooledObject.Reset() {
@@ -263,4 +280,21 @@
             yield return sub;
         else yield return expr;
+      }
+    }
+
+    public IReadOnlyList<Expression> Flatten() {
+      var result = new List<Expression>();
+      Flatten(result);
+      return result;
+    }
+
+    private void Flatten(List<Expression> result) {
+      result.AddRange(expressions);
+
+      for (var i = 0; i < expressions.Count; i++) {
+        var expr = expressions[i];
+        if (expr.IsProgram) {
+          ((PushProgram)expr).Flatten(result);
+        }
       }
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15189)
@@ -69,4 +69,6 @@
     }
 
+    void IPooledObject.Init() { }
+
     public void Reset() {
       State = default(T);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15189)
@@ -453,7 +453,7 @@
         .Where(x => !string.IsNullOrWhiteSpace(x))
         .Reverse()
-        .ToArray();
-
-      if (words.Length == 0) {
+        .ToList();
+
+      if (words.Count == 0) {
         interpreter.StringStack.Pop();
       } else {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15189)
@@ -25,5 +25,5 @@
       vectorStack.Top = vectorStack.Top
         .Take(vectorStack.Top.Count - 1)
-        .ToArray();
+        .ToList();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15189)
@@ -56,5 +56,5 @@
         }
 
-        vectorStack.Top = vector.Take(last).ToArray();
+        vectorStack.Top = vector.Take(last).ToList();
       }
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15189)
@@ -23,5 +23,5 @@
 
     protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
-      var vector = vectorStack.Pop().Reverse().ToArray();
+      var vector = vectorStack.Pop().Reverse().ToList();
       literalStack.Push(vector);
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15189)
@@ -25,5 +25,5 @@
     protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var literal = literalStack.Pop();
-      vectorStack.Top = vectorStack.Top.Where(x => !x.Equals(literal)).ToArray();
+      vectorStack.Top = vectorStack.Top.Where(x => !x.Equals(literal)).ToList();
     }
   }
@@ -92,6 +92,6 @@
   [PushExpression(
     StackTypes.StringVector,
+    "STRING[].REMOVE",
     "Removes all occurrences of the top STRING in the top STRING[].",
-    "STRING[].REMOVE",
     StackTypes.String)]
   public class StringVectorRemoveExpression : VectorRemoveExpression<string> {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15189)
@@ -42,5 +42,5 @@
       }
 
-      vectorStack.Top = vector.Skip(1).ToArray();
+      vectorStack.Top = vector.Skip(1).ToList();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15189)
@@ -25,5 +25,5 @@
 
     protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack) {
-      vectorStack.Top = vectorStack.Top.Reverse().ToArray();
+      vectorStack.Top = vectorStack.Top.Reverse().ToList();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15189)
@@ -51,5 +51,5 @@
       }
 
-      vectorStack.Top = vector.Skip(first).Take(lenght).ToArray();
+      vectorStack.Top = vector.Skip(first).Take(lenght).ToList();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15189)
@@ -53,5 +53,5 @@
       }
 
-      vectorStack.Top = vector.Take(count).ToArray();
+      vectorStack.Top = vector.Take(count).ToList();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ProblemDataExtensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ProblemDataExtensions.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ProblemDataExtensions.cs	(revision 15189)
@@ -0,0 +1,25 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  public static class ProblemDataExtensions {
+    public static void InitInExpressions(this ProblemData data, IEnabledExpressionsConfiguration config) {
+      if (data.TotalIntputArgumentCount >= 1) config.EnableExpression<In1Expression>();
+      if (data.TotalIntputArgumentCount >= 2) config.EnableExpression<In2Expression>();
+      if (data.TotalIntputArgumentCount >= 3) config.EnableExpression<In3Expression>();
+      if (data.TotalIntputArgumentCount >= 4) config.EnableExpression<In4Expression>();
+      if (data.TotalIntputArgumentCount >= 5) config.EnableExpression<In5Expression>();
+      if (data.TotalIntputArgumentCount >= 6) config.EnableExpression<In6Expression>();
+      if (data.TotalIntputArgumentCount >= 7) config.EnableExpression<In7Expression>();
+      if (data.TotalIntputArgumentCount >= 8) config.EnableExpression<In8Expression>();
+      if (data.TotalIntputArgumentCount >= 9) config.EnableExpression<In9Expression>();
+      if (data.TotalIntputArgumentCount == 10) config.EnableExpression<In10Expression>();
+
+      if (data.TotalIntputArgumentCount > 10)
+        throw new InvalidOperationException("More input arguments defined as InExpressions types");
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/StringBuilderExtensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/StringBuilderExtensions.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/StringBuilderExtensions.cs	(revision 15189)
@@ -0,0 +1,236 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
+  using System;
+  using System.Diagnostics;
+  using System.Globalization;
+  using System.Text;
+
+  public static class StringBuilderExtension {
+    // These digits are here in a static array to support hex with simple, easily-understandable code.
+    // Since A-Z don't sit next to 0-9 in the ascii table.
+    private static readonly char[] MsDigits =
+      {
+        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D',
+        'E', 'F'
+      };
+
+    //private static readonly ulong MsDefaultDecimalPlaces = 5; //< Matches standard .NET formatting dp's
+
+    private const char MsDefaultPadChar = '0';
+
+    //! Convert a given unsigned integer value to a string and concatenate onto the stringbuilder. Any base value allowed.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      ulong ulongVal,
+      ulong padAmount,
+      char padChar,
+      ulong baseVal) {
+      Debug.Assert((baseVal > 0) && (baseVal <= 16));
+
+      // Calculate length of integer when written out
+      ulong length = 0;
+      var lengthCalc = ulongVal;
+
+      do {
+        lengthCalc /= baseVal;
+        length++;
+      }
+      while (lengthCalc > 0);
+
+      // Pad out space for writing.
+      stringBuilder.Append(padChar, (int)Math.Max(padAmount, length));
+
+      var strpos = stringBuilder.Length;
+
+      // We're writing backwards, one character at a time.
+      while (length > 0) {
+        strpos--;
+
+        // Lookup from static char array, to cover hex values too
+        stringBuilder[strpos] = MsDigits[ulongVal % baseVal];
+
+        ulongVal /= baseVal;
+        length--;
+      }
+
+      return stringBuilder;
+    }
+
+    //! Convert a given unsigned integer value to a string and concatenate onto the stringbuilder. Assume no padding and base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, ulong ulongVal) {
+      stringBuilder.Concat(ulongVal, 0, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given unsigned integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, ulong ulongVal, ulong padAmount) {
+      stringBuilder.Concat(ulongVal, padAmount, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given unsigned integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      ulong ulongVal,
+      ulong padAmount,
+      char padChar) {
+      stringBuilder.Concat(ulongVal, padAmount, padChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Any base value allowed.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      long longVal,
+      ulong padAmount,
+      char padChar,
+      ulong baseVal) {
+      Debug.Assert((baseVal > 0) && (baseVal <= 16));
+
+      // Deal with negative numbers
+      if (longVal < 0) {
+        stringBuilder.Append('-');
+        var ulongVal = ulong.MaxValue - (ulong)longVal + 1; //< This is to deal with Int64.MinValue
+        stringBuilder.Concat(ulongVal, padAmount, padChar, baseVal);
+      } else {
+        stringBuilder.Concat((ulong)longVal, padAmount, padChar, baseVal);
+      }
+
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume no padding and base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, long longVal) {
+      stringBuilder.Concat(longVal, 0, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, long longVal, ulong padAmount) {
+      stringBuilder.Concat(longVal, padAmount, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      long longVal,
+      ulong padAmount,
+      char padChar) {
+      stringBuilder.Concat(longVal, padAmount, padChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Any base value allowed.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      int intVal,
+      ulong padAmount,
+      char padChar,
+      ulong baseVal) {
+      Debug.Assert((baseVal > 0) && (baseVal <= 16));
+
+      // Deal with negative numbers
+      if (intVal < 0) {
+        stringBuilder.Append('-');
+        var ulongVal = ulong.MaxValue - (ulong)intVal + 1; //< This is to deal with Int32.MinValue
+        stringBuilder.Concat(ulongVal, padAmount, padChar, baseVal);
+      } else {
+        stringBuilder.Concat((ulong)intVal, padAmount, padChar, baseVal);
+      }
+
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume no padding and base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, int intVal) {
+      stringBuilder.Concat(intVal, 0, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, int intVal, ulong padAmount) {
+      stringBuilder.Concat(intVal, padAmount, MsDefaultPadChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given signed integer value to a string and concatenate onto the stringbuilder. Assume base ten.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, int intVal, ulong padAmount, char padChar) {
+      stringBuilder.Concat(intVal, padAmount, padChar, 10);
+      return stringBuilder;
+    }
+
+    //! Convert a given double value to a string and concatenate onto the stringbuilder
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      double doubleVal,
+      uint decimalPlaces,
+      uint padAmount,
+      char padChar,
+      CultureInfo culturInfo = null) {
+      culturInfo = culturInfo ?? CultureInfo.CurrentCulture;
+
+      if (decimalPlaces == 0) {
+        // No decimal places, just round up and print it as an int
+
+        // Agh, Math.Floor() just works on doubles/decimals. Don't want to cast! Let's do this the old-fashioned way.
+        int intVal;
+        if (doubleVal >= 0.0d) intVal = (int)(doubleVal + 0.5d);
+        else intVal = (int)(doubleVal - 0.5d);
+
+        stringBuilder.Concat(intVal, padAmount, padChar, 10);
+      } else {
+        var intPart = (int)doubleVal;
+
+        // First part is easy, just cast to an integer
+        stringBuilder.Concat(intPart, padAmount, padChar, 10);
+
+        // Decimal point
+        var numberDecimalSeparator = Convert.ToChar(culturInfo.NumberFormat.NumberDecimalSeparator);
+        stringBuilder.Append(numberDecimalSeparator);
+
+        // Work out remainder we need to print after the d.p.
+        var remainder = Math.Abs(doubleVal - intPart);
+
+        // Multiply up to become an int that we can print
+        do {
+          remainder *= 10;
+          decimalPlaces--;
+        }
+        while (remainder > (int)remainder && decimalPlaces > 0);
+
+        // Round up. It's guaranteed to be a positive number, so no extra work required here.
+        remainder += 0.5d;
+
+        // All done, print that as an int!
+        stringBuilder.Concat((ulong)remainder, 0, '0', 10);
+      }
+      return stringBuilder;
+    }
+
+    //! Convert a given double value to a string and concatenate onto the stringbuilder. Assumes five decimal places, and no padding.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, double doubleVal, CultureInfo culturInfo = null) {
+      culturInfo = culturInfo ?? CultureInfo.CurrentCulture;
+
+      stringBuilder.Concat(doubleVal, (uint)culturInfo.NumberFormat.NumberDecimalDigits, 0, MsDefaultPadChar, culturInfo);
+      return stringBuilder;
+    }
+
+    //! Convert a given double value to a string and concatenate onto the stringbuilder. Assumes no padding.
+    public static StringBuilder Concat(this StringBuilder stringBuilder, double doubleVal, uint decimalPlaces, CultureInfo culturInfo = null) {
+      stringBuilder.Concat(doubleVal, decimalPlaces, 0, MsDefaultPadChar, culturInfo);
+      return stringBuilder;
+    }
+
+    //! Convert a given double value to a string and concatenate onto the stringbuilder.
+    public static StringBuilder Concat(
+      this StringBuilder stringBuilder,
+      double doubleVal,
+      uint decimalPlaces,
+      uint padAmount,
+      CultureInfo culturInfo = null) {
+
+      stringBuilder.Concat(doubleVal, decimalPlaces, padAmount, MsDefaultPadChar, culturInfo);
+      return stringBuilder;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15189)
@@ -38,18 +38,22 @@
       IRandom random,
       IReadOnlyErcOptions ercOptions) {
-      var x = random.NextDouble();
-      Expression expression = null;
+      //var x = random.NextDouble();
+      //Expression expression = null;
 
-      if (x < ercOptions.ErcProbability) {
-        var expressionType = ExpressionTable.NameToTypeTable[expressionName];
-        expression = CreateRandomErcExpression(
-            ExpressionTable.TypeToAttributeTable[expressionType].StackType,
-            random,
-            ercOptions);
-      }
+      //if (x < ercOptions.ErcProbability) {
+      //  var expressionType = ExpressionTable.NameToTypeTable[expressionName];
+      //  expression = CreateRandomErcExpression(
+      //      ExpressionTable.TypeToAttributeTable[expressionType].StackType,
+      //      random,
+      //      ercOptions);
+      //}
 
-      if (expression == null || expression is ExecNoopExpression) {
-        expression = ExpressionTable.GetExpression(expressionName);
-      }
+      //if (expression == null || expression is ExecNoopExpression) {
+      //  expression = ExpressionTable.GetExpression(expressionName);
+      //}
+
+      //return expression;
+
+      var expression = ExpressionTable.GetExpression(expressionName);
 
       return expression;
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs	(revision 15189)
@@ -23,5 +23,5 @@
       var code = RandomCode(maxPoints, random, pushGpConfiguration, customExpressions);
 
-      return PushProgram.Create(pool, code.ToArray());
+      return PushProgram.Create(pool, code.ToList());
     }
 
@@ -29,5 +29,5 @@
       var code = RandomCode(maxPoints, random, pushGpConfiguration, customExpressions);
 
-      return new PushProgram(code.ToArray());
+      return new PushProgram(code.ToList());
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15189)
@@ -0,0 +1,71 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Individual {
+  using System.Collections.Generic;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
+  using HeuristicLab.Random;
+
+  public static class IndividualExtensions {
+    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, ObjectPool<IRandom> randomPool) {
+      return individual.IntegerVector().ToPushProgram(config, randomPool);
+    }
+
+    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config) {
+      return individual.IntegerVector().ToPushProgram(config);
+    }
+
+    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, IRandom random) {
+      return individual.IntegerVector().ToPushProgram(config, random);
+    }
+
+    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, ObjectPool<IRandom> randomPool) {
+      var random = randomPool.Allocate();
+      var seed = vector.GetSeed();
+
+      random.Reset(seed);
+      var program = vector.ToPushProgram(config, random);
+      randomPool.Free(random);
+
+      return program;
+    }
+
+    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config) {
+      var seed = (uint)vector.GetSeed();
+      return vector.ToPushProgram(config, new MersenneTwister(seed));
+    }
+
+    public static int GetSeed(this IntegerVector vector) {
+      var seed = 17;
+      for (var i = 0; i < vector.Length; i++)
+        seed = seed * 23 + vector[i];
+      return seed;
+    }
+
+    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, IRandom random) {
+      //var currentIndex = 0;
+      //var close = 0;
+      var expressions = new List<Expression>(vector.Length);
+
+      for (var i = vector.Length - 1; i >= 0; i--) {
+        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
+          vector[i],
+          random,
+          config.EnabledExpressions,
+          config.ErcOptions);
+
+        expressions.Add(expression);
+      }
+
+      return new PushProgram(expressions);
+
+      //using (var mapper = IndividualMapper.Create()) {
+      //  return mapper.FromPlush(vector, ref currentIndex, ref close, 0, config, random);
+      //}
+    }
+  }
+}
